#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    int all = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        all += a[i];
    }
    vector<int> pref(n), suf(n);;
    vector<int> pref_mn(n), suf_mn(n);
    pref[0] = a[0];
    pref_mn[0] = a[0];
    suf[n - 1] = a[n - 1];
    suf_mn[n - 1] = a[n - 1];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + a[i];
        pref_mn[i] = min(pref_mn[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = suf[i + 1] + a[i];
        suf_mn[i] = min(suf_mn[i + 1], a[i]);
    }
    if (k == n) {
        sort(a.begin(), a.end());
        cout << a[n - 1] - a[0];
        return;
    }
    int ans = 0;
    for (int i = 0; i <= k; i++) {
        int l = -1 + i;
        int r = n - (k - i - 1);
        int sum = all;
        int mn = 1e18;
        if (l > -1) {
            sum -= pref[l];
            mn = min(mn, pref_mn[l]);
        }
        if (r < n) {
            sum -= suf[r];
            mn = min(mn, suf_mn[r]);
        }
        ans = max(ans, sum - mn);
    }
    cout << ans;
}
