#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

const int INF = 1e9;

struct Node {
    bool fir = 0;
    bool sec = 0;
};

void solve1() {
    int n, s;
    cin >> n >> s;
    vector<vector<int> > c(n + 1);
    int all = 0;
    vector<int> v;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        all += k;
        c[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> c[i][j];
            v.push_back(c[i][j]);
        }
    }
    vector<Node> dp(s + 1);
    vector<vector<vector<Node> > > pred(
        all + 1, vector<vector<Node> >(s + 1, vector<Node>(2)));
    dp[0].fir = 1;
    dp[0].sec = 1;
    int nowi = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < c[i].size(); j++) {
            vector<Node> new_dp(s + 1);
            nowi++;
            for (int k = 0; k <= s; k++) {
                if (j == 0) {
                    if (dp[k].sec) {
                        new_dp[k].fir = 1;
                        pred[nowi][k][0] = {0, 1};
                    }
                } else {
                    if (dp[k].fir) {
                        new_dp[k].fir = 1;
                        pred[nowi][k][0] = {0, 0};
                    }
                    if (dp[k].sec) {
                        new_dp[k].sec = 1;
                        pred[nowi][k][1] = {0, 1};
                    }
                }
                if (k >= c[i][j]) {
                    if (j != 0 && dp[k - c[i][j]].fir) {
                        new_dp[k].sec = 1;
                        pred[nowi][k][1] = {1, 0};
                    } else if (dp[k - c[i][j]].sec) {
                        new_dp[k].sec = 1;
                        pred[nowi][k][1] = {1, 1};
                    }
                }
            }
            dp = new_dp;
        }
    }
    if (!dp[s].sec) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    vector<bool> ans(all + 1);
    bool flag = 1;
    int ss = s;
    while (nowi > 0) {
        auto pp = pred[nowi][s][flag];
        if (pp.fir) {
            ans[nowi] = 1;
            s -= v[nowi - 1];
        }
        flag = pp.sec;
        nowi--;
    }
    int sum = 0;
    nowi = 0;
    for (int i = 1; i <= n; i++) {
        vector<int> now;
        for (int j = 0; j < c[i].size(); j++) {
            nowi++;
            if (ans[nowi]) {
                sum += c[i][j];
                now.push_back(j + 1);
            }
        }
        cout << now.size() << '\n';
        for (int j: now) {
            cout << j << ' ';
        }
        cout << '\n';
    }
    if (sum != ss) {
        exit(-1);
    }
}
