#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

void solve2();

int n, m, k;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> k;
    solve2();
    return 0;
    if (n == 3) {
        solve1();
    } else {
        solve2();
    }
}

const int INF = 1e9;
const int MOD = 1e9 + 7;
vector<vector<int> > a;
vector<pair<int, int> > fir;
vector<pair<int, int> > sec;
vector<vector<bool> > vis1;
vector<vector<bool> > vis2;
int ans = 0;

void f(int x1, int y1, int x2, int y2) {
    if (x1 == n - 1 && y1 == m - 1) {
        int cnt = 0;
        for (auto i: fir) {
            cnt += a[i.first][i.second];
        }
        for (auto i: sec) {
            cnt += a[i.first][i.second];
        }
        if (cnt == k) {
            ans++;
        }
    }
    vis1[x1][y1] = 1;
    vis2[x2][y2] = 1;
    if (vis2[x1][y1] || vis1[x2][y2]) {
        vis1[x1][y1] = 0;
        vis2[x2][y2] = 0;
        return;
    }
    fir.push_back({x1, y1});
    sec.push_back({x2, y2});
    for (int i1 = 0; i1 < 2; i1++) {
        for (int j1 = 0; j1 < 2; j1++) {
            for (int i2 = 0; i2 < 2; i2++) {
                for (int j2 = 0; j2 < 2; j2++) {
                    if (x1 + i1 == n || y1 + j1 == m || x2 - i2 == -1 || y2 - j2 == -1 || i1 + j1 != 1 || i2 + j2 != 1)
                        continue;
                    f(x1 + i1, y1 + j1, x2 - i2, y2 - j2);
                }
            }
        }
    }
    fir.pop_back();
    sec.pop_back();
    vis1[x1][y1] = 0;
    vis2[x2][y2] = 0;
}

void solve2() {
    a.resize(n, vector<int>(m));
    vis1.resize(n, vector<bool>(m));
    vis2.resize(n, vector<bool>(m));
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x][y] = 1;
    }
    f(0, 0, n - 1, m - 1);
    cout << ans % MOD;
}

void solve1() {
    int ans = 0;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x][y] = 1;
    }
    for (int fir = 0; fir < m; fir++) {
        for (int sec = 0; sec < m; sec++) {
            if (fir <= sec) continue;
            set<pair<int, int> > st;
            for (int j = 0; j <= fir; j++) {
                if (a[0][j]) {
                    st.insert({0, j});
                }
            }
            for (int j = fir; j < m; j++) {
                if (a[1][j]) {
                    st.insert({1, j});
                }
            }
            for (int j = 0; j <= sec; j++) {
                if (a[1][j]) {
                    st.insert({1, j});
                }
            }
            for (int j = sec; j < m; j++) {
                if (a[2][j]) {
                    st.insert({2, j});
                }
            }
            if (a[0][0]) {
                st.insert({0, 0});
            }
            if (a[n - 1][m - 1]) {
                st.insert({n - 1, m - 1});
            }
            if (st.size() == k) {
                ans++;
            }
        }
    }
    cout << ans * 2;
}
