#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

vector<int> pr = {2, 3, 5, 7};

int get(string s) {
    int n = s.size();
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (i != n) {
            ans += i * 4;
        }
    }
    vector<int> dp(n + 1);
    bool flag = true;
    vector<bool> suf(n + 1);
    suf[n] = (s[n - 1] - '0' >= 1);
    for (int i = n - 1; i > 0; i--) {
        suf[i] = suf[i + 1] & (s[i - 1] - '0' >= 1);
    }
    for (int i = 1; i <= n; i++) {
        dp[i] = dp[i - 1];
        if (flag) {
            if (s[i - 1] == '0') {
                return ans;
            } else if (s[i - 1] == '1') {
                continue;
            }
            flag = false;
            for (int j: pr) {
                if (j < (s[i - 1] - '0')) {
                    dp[i]++;
                } else if (j == (s[i - 1] - '0')) {
                    if (suf[i]) {
                        dp[i]++;
                    }
                }
            }
        } else {
            dp[i] += 4;
        }
    }
    return ans + dp[n];
}

void solve1() {
    string l, r;
    cin >> l >> r;
    map<char, int> mp;
    for (auto i: l) {
        mp[i]++;
    }
    auto fir = get(l);
    auto sec = get(r);
    int thr = 0;
    int n = l.size();
    for (auto i: pr) {
        if (mp[i + '0'] == 1 && mp['1'] == n - 1) {
            thr++;
        }
    }
    assert(thr < 2);
    assert(sec >= fir);
    cout << max(0ll, sec - fir + thr);
}
