#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int> >, rb_tree_tag,
    tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

const int INF = 1e18;

set<pair<int, int> > lr;
vector<int> l, r;
vector<int> h;

void update(int k) {
    int qqq = 0;
    int l1, r1, l2, r2;
    auto it2 = lr.upper_bound({k, INF});
    auto it1 = it2;
    it1--;
    l1 = (*(it1)).first;
    r1 = (*(it1)).second;
    l2 = (*(it2)).first;
    r2 = (*(it2)).second;
    lr.erase({l1, r1});
    lr.erase({l2, r2});
    for (int i = l1; i <= r1; i++) {
        r[i] = max(r[i], r[l2]);
    }
    for (int i = l2; i <= r2; i++) {
        l[i] = max(l[i], l[r1]);
    }
    int ans = 0;
    for (int i = l1; i <= r2; i++) {
        ans += min(l[i], r[i]) - h[i];
    }
    cout << ans << '\n';
    lr.insert({l1, r2});
}

void solve1() {
    int n;
    cin >> n;
    h.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; i++) {
        lr.insert({i, i});
        l[i] = h[i];
        r[i] = h[i];
    }
    ordered_set st;
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        k--;
        int kk = k;
        k += st.order_of_key({k + 1, 0});
        update(k);
        st.insert({kk, i});
    }
}
