#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

vector<int> pref, suf;
vector<int> pref_mn, suf_mn;
int all = 0;
int n;

int get(int x, int i) {
    int sum = all;
    int mn = 1e18;
    if (x != 0) {
        mn = min(mn, pref_mn[x - 1]);
        sum -= pref[x - 1];
    }
    if (i != n - 1) {
        mn = min(mn, suf_mn[i + 1]);
        sum -= suf[i + 1];
    }
    return abs(sum - mn);
}

void solve1() {
    int k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        all += a[i];
    }
    pref.resize(n);
    pref_mn.resize(n);
    suf_mn.resize(n);
    suf.resize(n);
    pref[0] = a[0];
    pref_mn[0] = a[0];
    suf[n - 1] = a[n - 1];
    suf_mn[n - 1] = a[n - 1];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + a[i];
        pref_mn[i] = min(pref_mn[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = suf[i + 1] + a[i];
        suf_mn[i] = min(suf_mn[i + 1], a[i]);
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int l = max(0ll, k - (n - i - 1) - 1), r = i;
        while (r - l > 1) {
            if (r - l <= 5) break;
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            int fir = get(m1, i);
            int sec = get(m2, i);
            if (fir > sec) {
                r = m2;
            } else {
                l = m1;
            }
        }
        for (int j = l; j <= r; j++) {
            ans = max(ans, get(l, i));
        }
    }
    cout << ans;
}
