#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

const int INF = 1e18;

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    int all = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        all += a[i];
    }
    vector<int> pref(n), suf(n);
    vector<int> pref_mn(n), suf_mn(n);
    pref[0] = a[0];
    pref_mn[0] = a[0];
    suf[n - 1] = a[n - 1];
    suf_mn[n - 1] = a[n - 1];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + a[i];
        pref_mn[i] = min(pref_mn[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = suf[i + 1] + a[i];
        suf_mn[i] = min(suf_mn[i + 1], a[i]);
    }
    if (k == n) {
        sort(a.begin(), a.end());
        cout << a[n - 1] - a[0];
        return;
    }
    if (k == 2) {
        cout << max(all - a[0] * 2, all - a[n - 1] * 2);
        return;
    }
    int ans = -INF;
    int mn = INF;
    for (int i = 0; i < n - 1; i++) {
        mn = min(mn, a[i]);
        int need_k = max(0ll, k - (i + 1) - 1);
        if (i != 0) {
            need_k--;
        }
        int sum = all - pref[i];
        int r = n - need_k;
        if (r < n) {
            sum -= suf[r];
        }
        ans = max(ans, sum - mn);
    }
    mn = INF;
    for (int i = n - 1; i > 0; i--) {
        mn = min(mn, a[i]);
        int need_k = max(0ll, k - (n - i) - 1);
        if (i != n - 1) {
            need_k--;
        }
        int sum = all - suf[i];
        int l = -1 + need_k;
        if (l > -1) {
            sum -= pref[l];
        }
        ans = max(ans, sum - mn);
    }
    cout << ans << '\n';
}
