#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

const int INF = 1e9;

void solve1() {
    int n, s;
    cin >> n >> s;
    vector<vector<int> > c(n + 1);
    int all = 0;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        all += k;
        c[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> c[i][j];
        }
    }
    vector<vector<vector<bool> > > dp(all + 1, vector<vector<bool> >(s + 1, vector<bool>(2)));
    vector<vector<vector<pair<int, bool> > > > pred(
        all + 1, vector<vector<pair<int, bool> > >(s + 1, vector<pair<int, bool> >(2)));
    dp[0][0][0] = 1;
    int nowi = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < c[i].size(); j++) {
            nowi++;
            for (int k = 0; k <= s; k++) {
                if (k >= c[i][j]) {
                    if (j == 0) {
                        if (dp[nowi - 1][k][1]) {
                            dp[nowi][k][0] = 1;
                            pred[nowi][k][0] = {k, 1};
                        }
                    } else {
                        if (dp[nowi - 1][k][0]) {
                            dp[nowi][k][0] = 1;
                            pred[nowi][k][0] = {k, 0};
                        }
                        if (dp[nowi - 1][k][1]) {
                            dp[nowi][k][1] = 1;
                            pred[nowi][k][1] = {k, 1};
                        }
                    }
                    if (dp[nowi - 1][k - c[i][j]][0]) {
                        dp[nowi][k][1] = 1;
                        pred[nowi][k][1] = {k - c[i][j], 0};
                    } else if (dp[nowi - 1][k - c[i][j]][1]) {
                        dp[nowi][k][1] = 1;
                        pred[nowi][k][1] = {k - c[i][j], 1};
                    }
                }
            }
        }
    }
    if (!dp[nowi][s][1]) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    vector<bool> ans(all + 1);
    bool flag = 1;
    int ss = s;
    while (nowi > 0) {
        auto pp = pred[nowi][s][flag];
        if (pp.first != s) {
            ans[nowi] = 1;
        }
        s = pp.first;
        flag = pp.second;
        nowi--;
    }
    int sum = 0;
    nowi = 0;
    for (int i = 1; i <= n; i++) {
        vector<int> now;
        for (int j = 0; j < c[i].size(); j++) {
            nowi++;
            if (ans[nowi]) {
                sum += c[i][j];
                now.push_back(j + 1);
            }
        }
        cout << now.size() << '\n';
        for (int j: now) {
            cout << j << ' ';
        }
        cout << '\n';
    }
    if (sum != ss) {
        exit(-1);
    }
}
