#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

const int INF = 1e9;

struct Node {
    bool fir = 0;
    bool sec = 0;
};

struct Nod {
    bool fir1 = 0;
    bool fir2 = 0;
    bool sec1 = 0;
    bool sec2 = 0;
};

void solve1() {
    int n, s;
    cin >> n >> s;
    int all = 0;
    vector<int> v;
    vector<int> c(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
        all += c[i];
        for (int j = 0; j < c[i]; j++) {
            int x;
            cin >> x;
            v.push_back(x);
        }
    }
    vector<Node> dp(s + 1);
    vector<vector<Nod> > pred(
        all + 1, vector<Nod>(s + 1));
    dp[0].fir = 1;
    dp[0].sec = 1;
    int nowi = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < c[i]; j++) {
            vector<Node> new_dp(s + 1);
            nowi++;
            for (int k = 0; k <= s; k++) {
                if (j == 0) {
                    if (dp[k].sec) {
                        new_dp[k].fir = 1;
                        pred[nowi][k].fir1 = 0;
                        pred[nowi][k].fir2 = 1;
                    }
                } else {
                    if (dp[k].fir) {
                        new_dp[k].fir = 1;
                        pred[nowi][k].fir1 = 0;
                        pred[nowi][k].fir2 = 0;
                    }
                    if (dp[k].sec) {
                        new_dp[k].sec = 1;
                        pred[nowi][k].sec1 = 0;
                        pred[nowi][k].sec2 = 1;
                    }
                }
                if (k >= v[nowi - 1]) {
                    if (j != 0 && dp[k - v[nowi - 1]].fir) {
                        new_dp[k].sec = 1;
                        pred[nowi][k].sec1 = 1;
                        pred[nowi][k].sec2 = 0;
                    } else if (dp[k - v[nowi - 1]].sec) {
                        new_dp[k].sec = 1;
                        pred[nowi][k].sec1 = 1;
                        pred[nowi][k].sec2 = 1;
                    }
                }
            }
            dp = new_dp;
        }
    }
    if (!dp[s].sec) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    vector<bool> ans(all + 1);
    bool flag = 1;
    while (nowi > 0) {
        if (flag == 0) {
            auto pp = pred[nowi][s];
            if (pp.fir1) {
                ans[nowi] = 1;
                s -= v[nowi - 1];
            }
            flag = pp.fir2;
            nowi--;
        } else {
            auto pp = pred[nowi][s];
            if (pp.sec1) {
                ans[nowi] = 1;
                s -= v[nowi - 1];
            }
            flag = pp.sec2;
            nowi--;
        }
    }
    nowi = 0;
    for (int i = 1; i <= n; i++) {
        int cnt = 0;
        int ii = nowi;
        for (int j = 0; j < c[i]; j++) {
            nowi++;
            if (ans[nowi]) {
                cnt++;
            }
        }
        cout << cnt << '\n';
        nowi = ii;
        for (int j = 0; j < c[i]; j++) {
            nowi++;
            if (ans[nowi]) {
                cout << j + 1 << ' ';
            }
        }
        cout << '\n';
    }
}
