#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve1();
}

const int INF = 1e9;
const int MOD = 1e9 + 7;

void solve1() {
    int n, m, k;
    cin >> n >> m >> k;
    int ans = 0;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x][y] = 1;
    }
    for (int fir = 0; fir < m; fir++) {
        for (int sec = 0; sec < m; sec++) {
            if (fir <= sec) continue;
            set<pair<int, int> > st;
            for (int j = 0; j <= fir; j++) {
                if (a[0][j]) {
                    st.insert({0, j});
                }
            }
            for (int j = fir; j < m; j++) {
                if (a[1][j]) {
                    st.insert({1, j});
                }
            }
            for (int j = 0; j <= sec; j++) {
                if (a[1][j]) {
                    st.insert({1, j});
                }
            }
            for (int j = sec; j < m; j++) {
                if (a[2][j]) {
                    st.insert({2, j});
                }
            }
            st.insert({0, 0});
            st.insert({n - 1, m - 1});
            if (st.size() == k) {
                ans++;
            }
        }
    }
    cout << ans * 2;
}
